unit schVentasTerminadasClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_VentasTerminadasCrossTab = '{E35531EF-55AE-4A00-823F-5B7AD2AC3170}';
  RID_VentasTerminadas = '{D098E936-4B28-485D-8B90-913C71342300}';

  { Data table names }
  nme_VentasTerminadasCrossTab = 'VentasTerminadasCrossTab';
  nme_VentasTerminadas = 'VentasTerminadas';

  { VentasTerminadasCrossTab fields }

  { VentasTerminadasCrossTab field indexes }

  { VentasTerminadas fields }
  fld_VentasTerminadasNUMINF = 'NUMINF';
  fld_VentasTerminadasCLAVE1 = 'CLAVE1';
  fld_VentasTerminadasCLAVE2 = 'CLAVE2';
  fld_VentasTerminadasCLAVE3 = 'CLAVE3';
  fld_VentasTerminadasFECHA = 'FECHA';
  fld_VentasTerminadasDIA = 'DIA';
  fld_VentasTerminadasDIASEMANA = 'DIASEMANA';
  fld_VentasTerminadasMES = 'MES';
  fld_VentasTerminadasANO = 'ANO';
  fld_VentasTerminadasCENTRO = 'CENTRO';
  fld_VentasTerminadasVENDEDOR = 'VENDEDOR';
  fld_VentasTerminadasNUMTALON = 'NUMTALON';
  fld_VentasTerminadasCODIGO = 'CODIGO';
  fld_VentasTerminadasPRODUCTO = 'PRODUCTO';
  fld_VentasTerminadasGRUPOPRODUCTO = 'GRUPOPRODUCTO';
  fld_VentasTerminadasTIPOPRODUCTO = 'TIPOPRODUCTO';
  fld_VentasTerminadasCOLECCION = 'COLECCION';
  fld_VentasTerminadasCOLOR = 'COLOR';
  fld_VentasTerminadasTALLA = 'TALLA';
  fld_VentasTerminadasTALLA38 = 'TALLA38';
  fld_VentasTerminadasTALLA40 = 'TALLA40';
  fld_VentasTerminadasTALLA42 = 'TALLA42';
  fld_VentasTerminadasTALLA44 = 'TALLA44';
  fld_VentasTerminadasTALLA46 = 'TALLA46';
  fld_VentasTerminadasTALLA48 = 'TALLA48';
  fld_VentasTerminadasVTATERMDEV = 'VTATERMDEV';
  fld_VentasTerminadasVTAFINALRESC = 'VTAFINALRESC';
  fld_VentasTerminadasVENTAS = 'VENTAS';
  fld_VentasTerminadasDEVOLUCIONES = 'DEVOLUCIONES';
  fld_VentasTerminadasTOTAL = 'TOTAL';
  fld_VentasTerminadasVALTERMDEV = 'VALTERMDEV';
  fld_VentasTerminadasVALFINALRESC = 'VALFINALRESC';
  fld_VentasTerminadasVALVEN = 'VALVEN';
  fld_VentasTerminadasVALDEV = 'VALDEV';
  fld_VentasTerminadasVALTOT = 'VALTOT';

  { VentasTerminadas field indexes }
  idx_VentasTerminadasNUMINF = 0;
  idx_VentasTerminadasCLAVE1 = 1;
  idx_VentasTerminadasCLAVE2 = 2;
  idx_VentasTerminadasCLAVE3 = 3;
  idx_VentasTerminadasFECHA = 4;
  idx_VentasTerminadasDIA = 5;
  idx_VentasTerminadasDIASEMANA = 6;
  idx_VentasTerminadasMES = 7;
  idx_VentasTerminadasANO = 8;
  idx_VentasTerminadasCENTRO = 9;
  idx_VentasTerminadasVENDEDOR = 10;
  idx_VentasTerminadasNUMTALON = 11;
  idx_VentasTerminadasCODIGO = 12;
  idx_VentasTerminadasPRODUCTO = 13;
  idx_VentasTerminadasGRUPOPRODUCTO = 14;
  idx_VentasTerminadasTIPOPRODUCTO = 15;
  idx_VentasTerminadasCOLECCION = 16;
  idx_VentasTerminadasCOLOR = 17;
  idx_VentasTerminadasTALLA = 18;
  idx_VentasTerminadasTALLA38 = 19;
  idx_VentasTerminadasTALLA40 = 20;
  idx_VentasTerminadasTALLA42 = 21;
  idx_VentasTerminadasTALLA44 = 22;
  idx_VentasTerminadasTALLA46 = 23;
  idx_VentasTerminadasTALLA48 = 24;
  idx_VentasTerminadasVTATERMDEV = 25;
  idx_VentasTerminadasVTAFINALRESC = 26;
  idx_VentasTerminadasVENTAS = 27;
  idx_VentasTerminadasDEVOLUCIONES = 28;
  idx_VentasTerminadasTOTAL = 29;
  idx_VentasTerminadasVALTERMDEV = 30;
  idx_VentasTerminadasVALFINALRESC = 31;
  idx_VentasTerminadasVALVEN = 32;
  idx_VentasTerminadasVALDEV = 33;
  idx_VentasTerminadasVALTOT = 34;

type
  { IVentasTerminadasCrossTab }
  IVentasTerminadasCrossTab = interface(IDAStronglyTypedDataTable)
  ['{7F43FB66-B68A-4E2E-BF67-E314FDE24117}']
    { Property getters and setters }


    { Properties }
  end;

  { TVentasTerminadasCrossTabDataTableRules }
  TVentasTerminadasCrossTabDataTableRules = class(TDADataTableRules, IVentasTerminadasCrossTab)
  private
  protected
    { Property getters and setters }

    { Properties }

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IVentasTerminadas }
  IVentasTerminadas = interface(IDAStronglyTypedDataTable)
  ['{6861A381-9EBD-4816-8EAC-5B2EDB0ED191}']
    { Property getters and setters }
    function GetNUMINFValue: String;
    procedure SetNUMINFValue(const aValue: String);
    function GetNUMINFIsNull: Boolean;
    procedure SetNUMINFIsNull(const aValue: Boolean);
    function GetCLAVE1Value: TBcd;
    procedure SetCLAVE1Value(const aValue: TBcd);
    function GetCLAVE1IsNull: Boolean;
    procedure SetCLAVE1IsNull(const aValue: Boolean);
    function GetCLAVE2Value: Integer;
    procedure SetCLAVE2Value(const aValue: Integer);
    function GetCLAVE2IsNull: Boolean;
    procedure SetCLAVE2IsNull(const aValue: Boolean);
    function GetCLAVE3Value: Integer;
    procedure SetCLAVE3Value(const aValue: Integer);
    function GetCLAVE3IsNull: Boolean;
    procedure SetCLAVE3IsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetDIAValue: Integer;
    procedure SetDIAValue(const aValue: Integer);
    function GetDIAIsNull: Boolean;
    procedure SetDIAIsNull(const aValue: Boolean);
    function GetDIASEMANAValue: WideString;
    procedure SetDIASEMANAValue(const aValue: WideString);
    function GetDIASEMANAIsNull: Boolean;
    procedure SetDIASEMANAIsNull(const aValue: Boolean);
    function GetMESValue: WideString;
    procedure SetMESValue(const aValue: WideString);
    function GetMESIsNull: Boolean;
    procedure SetMESIsNull(const aValue: Boolean);
    function GetANOValue: Integer;
    procedure SetANOValue(const aValue: Integer);
    function GetANOIsNull: Boolean;
    procedure SetANOIsNull(const aValue: Boolean);
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCENTROIsNull: Boolean;
    procedure SetCENTROIsNull(const aValue: Boolean);
    function GetVENDEDORValue: String;
    procedure SetVENDEDORValue(const aValue: String);
    function GetVENDEDORIsNull: Boolean;
    procedure SetVENDEDORIsNull(const aValue: Boolean);
    function GetNUMTALONValue: String;
    procedure SetNUMTALONValue(const aValue: String);
    function GetNUMTALONIsNull: Boolean;
    procedure SetNUMTALONIsNull(const aValue: Boolean);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetCODIGOIsNull: Boolean;
    procedure SetCODIGOIsNull(const aValue: Boolean);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetPRODUCTOIsNull: Boolean;
    procedure SetPRODUCTOIsNull(const aValue: Boolean);
    function GetGRUPOPRODUCTOValue: String;
    procedure SetGRUPOPRODUCTOValue(const aValue: String);
    function GetGRUPOPRODUCTOIsNull: Boolean;
    procedure SetGRUPOPRODUCTOIsNull(const aValue: Boolean);
    function GetTIPOPRODUCTOValue: String;
    procedure SetTIPOPRODUCTOValue(const aValue: String);
    function GetTIPOPRODUCTOIsNull: Boolean;
    procedure SetTIPOPRODUCTOIsNull(const aValue: Boolean);
    function GetCOLECCIONValue: String;
    procedure SetCOLECCIONValue(const aValue: String);
    function GetCOLECCIONIsNull: Boolean;
    procedure SetCOLECCIONIsNull(const aValue: Boolean);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetCOLORIsNull: Boolean;
    procedure SetCOLORIsNull(const aValue: Boolean);
    function GetTALLAValue: String;
    procedure SetTALLAValue(const aValue: String);
    function GetTALLAIsNull: Boolean;
    procedure SetTALLAIsNull(const aValue: Boolean);
    function GetTALLA38Value: TBcd;
    procedure SetTALLA38Value(const aValue: TBcd);
    function GetTALLA38IsNull: Boolean;
    procedure SetTALLA38IsNull(const aValue: Boolean);
    function GetTALLA40Value: TBcd;
    procedure SetTALLA40Value(const aValue: TBcd);
    function GetTALLA40IsNull: Boolean;
    procedure SetTALLA40IsNull(const aValue: Boolean);
    function GetTALLA42Value: TBcd;
    procedure SetTALLA42Value(const aValue: TBcd);
    function GetTALLA42IsNull: Boolean;
    procedure SetTALLA42IsNull(const aValue: Boolean);
    function GetTALLA44Value: TBcd;
    procedure SetTALLA44Value(const aValue: TBcd);
    function GetTALLA44IsNull: Boolean;
    procedure SetTALLA44IsNull(const aValue: Boolean);
    function GetTALLA46Value: TBcd;
    procedure SetTALLA46Value(const aValue: TBcd);
    function GetTALLA46IsNull: Boolean;
    procedure SetTALLA46IsNull(const aValue: Boolean);
    function GetTALLA48Value: TBcd;
    procedure SetTALLA48Value(const aValue: TBcd);
    function GetTALLA48IsNull: Boolean;
    procedure SetTALLA48IsNull(const aValue: Boolean);
    function GetVTATERMDEVValue: TBcd;
    procedure SetVTATERMDEVValue(const aValue: TBcd);
    function GetVTATERMDEVIsNull: Boolean;
    procedure SetVTATERMDEVIsNull(const aValue: Boolean);
    function GetVTAFINALRESCValue: TBcd;
    procedure SetVTAFINALRESCValue(const aValue: TBcd);
    function GetVTAFINALRESCIsNull: Boolean;
    procedure SetVTAFINALRESCIsNull(const aValue: Boolean);
    function GetVENTASValue: TBcd;
    procedure SetVENTASValue(const aValue: TBcd);
    function GetVENTASIsNull: Boolean;
    procedure SetVENTASIsNull(const aValue: Boolean);
    function GetDEVOLUCIONESValue: TBcd;
    procedure SetDEVOLUCIONESValue(const aValue: TBcd);
    function GetDEVOLUCIONESIsNull: Boolean;
    procedure SetDEVOLUCIONESIsNull(const aValue: Boolean);
    function GetTOTALValue: TBcd;
    procedure SetTOTALValue(const aValue: TBcd);
    function GetTOTALIsNull: Boolean;
    procedure SetTOTALIsNull(const aValue: Boolean);
    function GetVALTERMDEVValue: Currency;
    procedure SetVALTERMDEVValue(const aValue: Currency);
    function GetVALTERMDEVIsNull: Boolean;
    procedure SetVALTERMDEVIsNull(const aValue: Boolean);
    function GetVALFINALRESCValue: Currency;
    procedure SetVALFINALRESCValue(const aValue: Currency);
    function GetVALFINALRESCIsNull: Boolean;
    procedure SetVALFINALRESCIsNull(const aValue: Boolean);
    function GetVALVENValue: Currency;
    procedure SetVALVENValue(const aValue: Currency);
    function GetVALVENIsNull: Boolean;
    procedure SetVALVENIsNull(const aValue: Boolean);
    function GetVALDEVValue: Currency;
    procedure SetVALDEVValue(const aValue: Currency);
    function GetVALDEVIsNull: Boolean;
    procedure SetVALDEVIsNull(const aValue: Boolean);
    function GetVALTOTValue: Currency;
    procedure SetVALTOTValue(const aValue: Currency);
    function GetVALTOTIsNull: Boolean;
    procedure SetVALTOTIsNull(const aValue: Boolean);


    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: TBcd read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property DIA: Integer read GetDIAValue write SetDIAValue;
    property DIAIsNull: Boolean read GetDIAIsNull write SetDIAIsNull;
    property DIASEMANA: WideString read GetDIASEMANAValue write SetDIASEMANAValue;
    property DIASEMANAIsNull: Boolean read GetDIASEMANAIsNull write SetDIASEMANAIsNull;
    property MES: WideString read GetMESValue write SetMESValue;
    property MESIsNull: Boolean read GetMESIsNull write SetMESIsNull;
    property ANO: Integer read GetANOValue write SetANOValue;
    property ANOIsNull: Boolean read GetANOIsNull write SetANOIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull: Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull: Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property GRUPOPRODUCTO: String read GetGRUPOPRODUCTOValue write SetGRUPOPRODUCTOValue;
    property GRUPOPRODUCTOIsNull: Boolean read GetGRUPOPRODUCTOIsNull write SetGRUPOPRODUCTOIsNull;
    property TIPOPRODUCTO: String read GetTIPOPRODUCTOValue write SetTIPOPRODUCTOValue;
    property TIPOPRODUCTOIsNull: Boolean read GetTIPOPRODUCTOIsNull write SetTIPOPRODUCTOIsNull;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLECCIONIsNull: Boolean read GetCOLECCIONIsNull write SetCOLECCIONIsNull;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull: Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull: Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property TALLA38: TBcd read GetTALLA38Value write SetTALLA38Value;
    property TALLA38IsNull: Boolean read GetTALLA38IsNull write SetTALLA38IsNull;
    property TALLA40: TBcd read GetTALLA40Value write SetTALLA40Value;
    property TALLA40IsNull: Boolean read GetTALLA40IsNull write SetTALLA40IsNull;
    property TALLA42: TBcd read GetTALLA42Value write SetTALLA42Value;
    property TALLA42IsNull: Boolean read GetTALLA42IsNull write SetTALLA42IsNull;
    property TALLA44: TBcd read GetTALLA44Value write SetTALLA44Value;
    property TALLA44IsNull: Boolean read GetTALLA44IsNull write SetTALLA44IsNull;
    property TALLA46: TBcd read GetTALLA46Value write SetTALLA46Value;
    property TALLA46IsNull: Boolean read GetTALLA46IsNull write SetTALLA46IsNull;
    property TALLA48: TBcd read GetTALLA48Value write SetTALLA48Value;
    property TALLA48IsNull: Boolean read GetTALLA48IsNull write SetTALLA48IsNull;
    property VTATERMDEV: TBcd read GetVTATERMDEVValue write SetVTATERMDEVValue;
    property VTATERMDEVIsNull: Boolean read GetVTATERMDEVIsNull write SetVTATERMDEVIsNull;
    property VTAFINALRESC: TBcd read GetVTAFINALRESCValue write SetVTAFINALRESCValue;
    property VTAFINALRESCIsNull: Boolean read GetVTAFINALRESCIsNull write SetVTAFINALRESCIsNull;
    property VENTAS: TBcd read GetVENTASValue write SetVENTASValue;
    property VENTASIsNull: Boolean read GetVENTASIsNull write SetVENTASIsNull;
    property DEVOLUCIONES: TBcd read GetDEVOLUCIONESValue write SetDEVOLUCIONESValue;
    property DEVOLUCIONESIsNull: Boolean read GetDEVOLUCIONESIsNull write SetDEVOLUCIONESIsNull;
    property TOTAL: TBcd read GetTOTALValue write SetTOTALValue;
    property TOTALIsNull: Boolean read GetTOTALIsNull write SetTOTALIsNull;
    property VALTERMDEV: Currency read GetVALTERMDEVValue write SetVALTERMDEVValue;
    property VALTERMDEVIsNull: Boolean read GetVALTERMDEVIsNull write SetVALTERMDEVIsNull;
    property VALFINALRESC: Currency read GetVALFINALRESCValue write SetVALFINALRESCValue;
    property VALFINALRESCIsNull: Boolean read GetVALFINALRESCIsNull write SetVALFINALRESCIsNull;
    property VALVEN: Currency read GetVALVENValue write SetVALVENValue;
    property VALVENIsNull: Boolean read GetVALVENIsNull write SetVALVENIsNull;
    property VALDEV: Currency read GetVALDEVValue write SetVALDEVValue;
    property VALDEVIsNull: Boolean read GetVALDEVIsNull write SetVALDEVIsNull;
    property VALTOT: Currency read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
  end;

  { TVentasTerminadasDataTableRules }
  TVentasTerminadasDataTableRules = class(TDADataTableRules, IVentasTerminadas)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: TBcd; virtual;
    procedure SetCLAVE1Value(const aValue: TBcd); virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetDIAValue: Integer; virtual;
    procedure SetDIAValue(const aValue: Integer); virtual;
    function GetDIAIsNull: Boolean; virtual;
    procedure SetDIAIsNull(const aValue: Boolean); virtual;
    function GetDIASEMANAValue: WideString; virtual;
    procedure SetDIASEMANAValue(const aValue: WideString); virtual;
    function GetDIASEMANAIsNull: Boolean; virtual;
    procedure SetDIASEMANAIsNull(const aValue: Boolean); virtual;
    function GetMESValue: WideString; virtual;
    procedure SetMESValue(const aValue: WideString); virtual;
    function GetMESIsNull: Boolean; virtual;
    procedure SetMESIsNull(const aValue: Boolean); virtual;
    function GetANOValue: Integer; virtual;
    procedure SetANOValue(const aValue: Integer); virtual;
    function GetANOIsNull: Boolean; virtual;
    procedure SetANOIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCENTROIsNull: Boolean; virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetCODIGOIsNull: Boolean; virtual;
    procedure SetCODIGOIsNull(const aValue: Boolean); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetPRODUCTOIsNull: Boolean; virtual;
    procedure SetPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetGRUPOPRODUCTOValue: String; virtual;
    procedure SetGRUPOPRODUCTOValue(const aValue: String); virtual;
    function GetGRUPOPRODUCTOIsNull: Boolean; virtual;
    procedure SetGRUPOPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetTIPOPRODUCTOValue: String; virtual;
    procedure SetTIPOPRODUCTOValue(const aValue: String); virtual;
    function GetTIPOPRODUCTOIsNull: Boolean; virtual;
    procedure SetTIPOPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetCOLECCIONValue: String; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    function GetCOLECCIONIsNull: Boolean; virtual;
    procedure SetCOLECCIONIsNull(const aValue: Boolean); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetCOLORIsNull: Boolean; virtual;
    procedure SetCOLORIsNull(const aValue: Boolean); virtual;
    function GetTALLAValue: String; virtual;
    procedure SetTALLAValue(const aValue: String); virtual;
    function GetTALLAIsNull: Boolean; virtual;
    procedure SetTALLAIsNull(const aValue: Boolean); virtual;
    function GetTALLA38Value: TBcd; virtual;
    procedure SetTALLA38Value(const aValue: TBcd); virtual;
    function GetTALLA38IsNull: Boolean; virtual;
    procedure SetTALLA38IsNull(const aValue: Boolean); virtual;
    function GetTALLA40Value: TBcd; virtual;
    procedure SetTALLA40Value(const aValue: TBcd); virtual;
    function GetTALLA40IsNull: Boolean; virtual;
    procedure SetTALLA40IsNull(const aValue: Boolean); virtual;
    function GetTALLA42Value: TBcd; virtual;
    procedure SetTALLA42Value(const aValue: TBcd); virtual;
    function GetTALLA42IsNull: Boolean; virtual;
    procedure SetTALLA42IsNull(const aValue: Boolean); virtual;
    function GetTALLA44Value: TBcd; virtual;
    procedure SetTALLA44Value(const aValue: TBcd); virtual;
    function GetTALLA44IsNull: Boolean; virtual;
    procedure SetTALLA44IsNull(const aValue: Boolean); virtual;
    function GetTALLA46Value: TBcd; virtual;
    procedure SetTALLA46Value(const aValue: TBcd); virtual;
    function GetTALLA46IsNull: Boolean; virtual;
    procedure SetTALLA46IsNull(const aValue: Boolean); virtual;
    function GetTALLA48Value: TBcd; virtual;
    procedure SetTALLA48Value(const aValue: TBcd); virtual;
    function GetTALLA48IsNull: Boolean; virtual;
    procedure SetTALLA48IsNull(const aValue: Boolean); virtual;
    function GetVTATERMDEVValue: TBcd; virtual;
    procedure SetVTATERMDEVValue(const aValue: TBcd); virtual;
    function GetVTATERMDEVIsNull: Boolean; virtual;
    procedure SetVTATERMDEVIsNull(const aValue: Boolean); virtual;
    function GetVTAFINALRESCValue: TBcd; virtual;
    procedure SetVTAFINALRESCValue(const aValue: TBcd); virtual;
    function GetVTAFINALRESCIsNull: Boolean; virtual;
    procedure SetVTAFINALRESCIsNull(const aValue: Boolean); virtual;
    function GetVENTASValue: TBcd; virtual;
    procedure SetVENTASValue(const aValue: TBcd); virtual;
    function GetVENTASIsNull: Boolean; virtual;
    procedure SetVENTASIsNull(const aValue: Boolean); virtual;
    function GetDEVOLUCIONESValue: TBcd; virtual;
    procedure SetDEVOLUCIONESValue(const aValue: TBcd); virtual;
    function GetDEVOLUCIONESIsNull: Boolean; virtual;
    procedure SetDEVOLUCIONESIsNull(const aValue: Boolean); virtual;
    function GetTOTALValue: TBcd; virtual;
    procedure SetTOTALValue(const aValue: TBcd); virtual;
    function GetTOTALIsNull: Boolean; virtual;
    procedure SetTOTALIsNull(const aValue: Boolean); virtual;
    function GetVALTERMDEVValue: Currency; virtual;
    procedure SetVALTERMDEVValue(const aValue: Currency); virtual;
    function GetVALTERMDEVIsNull: Boolean; virtual;
    procedure SetVALTERMDEVIsNull(const aValue: Boolean); virtual;
    function GetVALFINALRESCValue: Currency; virtual;
    procedure SetVALFINALRESCValue(const aValue: Currency); virtual;
    function GetVALFINALRESCIsNull: Boolean; virtual;
    procedure SetVALFINALRESCIsNull(const aValue: Boolean); virtual;
    function GetVALVENValue: Currency; virtual;
    procedure SetVALVENValue(const aValue: Currency); virtual;
    function GetVALVENIsNull: Boolean; virtual;
    procedure SetVALVENIsNull(const aValue: Boolean); virtual;
    function GetVALDEVValue: Currency; virtual;
    procedure SetVALDEVValue(const aValue: Currency); virtual;
    function GetVALDEVIsNull: Boolean; virtual;
    procedure SetVALDEVIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: Currency; virtual;
    procedure SetVALTOTValue(const aValue: Currency); virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull: Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property CLAVE1: TBcd read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull: Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull: Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull: Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property DIA: Integer read GetDIAValue write SetDIAValue;
    property DIAIsNull: Boolean read GetDIAIsNull write SetDIAIsNull;
    property DIASEMANA: WideString read GetDIASEMANAValue write SetDIASEMANAValue;
    property DIASEMANAIsNull: Boolean read GetDIASEMANAIsNull write SetDIASEMANAIsNull;
    property MES: WideString read GetMESValue write SetMESValue;
    property MESIsNull: Boolean read GetMESIsNull write SetMESIsNull;
    property ANO: Integer read GetANOValue write SetANOValue;
    property ANOIsNull: Boolean read GetANOIsNull write SetANOIsNull;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull: Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull: Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull: Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull: Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull: Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property GRUPOPRODUCTO: String read GetGRUPOPRODUCTOValue write SetGRUPOPRODUCTOValue;
    property GRUPOPRODUCTOIsNull: Boolean read GetGRUPOPRODUCTOIsNull write SetGRUPOPRODUCTOIsNull;
    property TIPOPRODUCTO: String read GetTIPOPRODUCTOValue write SetTIPOPRODUCTOValue;
    property TIPOPRODUCTOIsNull: Boolean read GetTIPOPRODUCTOIsNull write SetTIPOPRODUCTOIsNull;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLECCIONIsNull: Boolean read GetCOLECCIONIsNull write SetCOLECCIONIsNull;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull: Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull: Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property TALLA38: TBcd read GetTALLA38Value write SetTALLA38Value;
    property TALLA38IsNull: Boolean read GetTALLA38IsNull write SetTALLA38IsNull;
    property TALLA40: TBcd read GetTALLA40Value write SetTALLA40Value;
    property TALLA40IsNull: Boolean read GetTALLA40IsNull write SetTALLA40IsNull;
    property TALLA42: TBcd read GetTALLA42Value write SetTALLA42Value;
    property TALLA42IsNull: Boolean read GetTALLA42IsNull write SetTALLA42IsNull;
    property TALLA44: TBcd read GetTALLA44Value write SetTALLA44Value;
    property TALLA44IsNull: Boolean read GetTALLA44IsNull write SetTALLA44IsNull;
    property TALLA46: TBcd read GetTALLA46Value write SetTALLA46Value;
    property TALLA46IsNull: Boolean read GetTALLA46IsNull write SetTALLA46IsNull;
    property TALLA48: TBcd read GetTALLA48Value write SetTALLA48Value;
    property TALLA48IsNull: Boolean read GetTALLA48IsNull write SetTALLA48IsNull;
    property VTATERMDEV: TBcd read GetVTATERMDEVValue write SetVTATERMDEVValue;
    property VTATERMDEVIsNull: Boolean read GetVTATERMDEVIsNull write SetVTATERMDEVIsNull;
    property VTAFINALRESC: TBcd read GetVTAFINALRESCValue write SetVTAFINALRESCValue;
    property VTAFINALRESCIsNull: Boolean read GetVTAFINALRESCIsNull write SetVTAFINALRESCIsNull;
    property VENTAS: TBcd read GetVENTASValue write SetVENTASValue;
    property VENTASIsNull: Boolean read GetVENTASIsNull write SetVENTASIsNull;
    property DEVOLUCIONES: TBcd read GetDEVOLUCIONESValue write SetDEVOLUCIONESValue;
    property DEVOLUCIONESIsNull: Boolean read GetDEVOLUCIONESIsNull write SetDEVOLUCIONESIsNull;
    property TOTAL: TBcd read GetTOTALValue write SetTOTALValue;
    property TOTALIsNull: Boolean read GetTOTALIsNull write SetTOTALIsNull;
    property VALTERMDEV: Currency read GetVALTERMDEVValue write SetVALTERMDEVValue;
    property VALTERMDEVIsNull: Boolean read GetVALTERMDEVIsNull write SetVALTERMDEVIsNull;
    property VALFINALRESC: Currency read GetVALFINALRESCValue write SetVALFINALRESCValue;
    property VALFINALRESCIsNull: Boolean read GetVALFINALRESCIsNull write SetVALFINALRESCIsNull;
    property VALVEN: Currency read GetVALVENValue write SetVALVENValue;
    property VALVENIsNull: Boolean read GetVALVENIsNull write SetVALVENIsNull;
    property VALDEV: Currency read GetVALDEVValue write SetVALDEVValue;
    property VALDEVIsNull: Boolean read GetVALDEVIsNull write SetVALDEVIsNull;
    property VALTOT: Currency read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull: Boolean read GetVALTOTIsNull write SetVALTOTIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TVentasTerminadasCrossTabDataTableRules }
constructor TVentasTerminadasCrossTabDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TVentasTerminadasCrossTabDataTableRules.Destroy;
begin
  inherited;
end;


{ TVentasTerminadasDataTableRules }
constructor TVentasTerminadasDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TVentasTerminadasDataTableRules.Destroy;
begin
  inherited;
end;

function TVentasTerminadasDataTableRules.GetNUMINFValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasNUMINF].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetNUMINFValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasNUMINF].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetNUMINFIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasNUMINF].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasNUMINF].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCLAVE1Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE1].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE1Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasCLAVE1].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetCLAVE1IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE1].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCLAVE1].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCLAVE2Value: Integer;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE2].AsInteger;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE2Value(const aValue: Integer);
begin
  DataTable.Fields[idx_VentasTerminadasCLAVE2].AsInteger := aValue;
end;

function TVentasTerminadasDataTableRules.GetCLAVE2IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE2].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCLAVE2].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCLAVE3Value: Integer;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE3].AsInteger;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE3Value(const aValue: Integer);
begin
  DataTable.Fields[idx_VentasTerminadasCLAVE3].AsInteger := aValue;
end;

function TVentasTerminadasDataTableRules.GetCLAVE3IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCLAVE3].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCLAVE3].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_VentasTerminadasFECHA].AsDateTime;
end;

procedure TVentasTerminadasDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_VentasTerminadasFECHA].AsDateTime := aValue;
end;

function TVentasTerminadasDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasFECHA].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasFECHA].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetDIAValue: Integer;
begin
  result := DataTable.Fields[idx_VentasTerminadasDIA].AsInteger;
end;

procedure TVentasTerminadasDataTableRules.SetDIAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_VentasTerminadasDIA].AsInteger := aValue;
end;

function TVentasTerminadasDataTableRules.GetDIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasDIA].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetDIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasDIA].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetDIASEMANAValue: WideString;
begin
  result := DataTable.Fields[idx_VentasTerminadasDIASEMANA].AsWideString;
end;

procedure TVentasTerminadasDataTableRules.SetDIASEMANAValue(const aValue: WideString);
begin
  DataTable.Fields[idx_VentasTerminadasDIASEMANA].AsWideString := aValue;
end;

function TVentasTerminadasDataTableRules.GetDIASEMANAIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasDIASEMANA].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetDIASEMANAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasDIASEMANA].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetMESValue: WideString;
begin
  result := DataTable.Fields[idx_VentasTerminadasMES].AsWideString;
end;

procedure TVentasTerminadasDataTableRules.SetMESValue(const aValue: WideString);
begin
  DataTable.Fields[idx_VentasTerminadasMES].AsWideString := aValue;
end;

function TVentasTerminadasDataTableRules.GetMESIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasMES].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetMESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasMES].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetANOValue: Integer;
begin
  result := DataTable.Fields[idx_VentasTerminadasANO].AsInteger;
end;

procedure TVentasTerminadasDataTableRules.SetANOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_VentasTerminadasANO].AsInteger := aValue;
end;

function TVentasTerminadasDataTableRules.GetANOIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasANO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetANOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasANO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasCENTRO].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasCENTRO].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetCENTROIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCENTRO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCENTRO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasVENDEDOR].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasVENDEDOR].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetVENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVENDEDOR].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVENDEDOR].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetNUMTALONValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasNUMTALON].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetNUMTALONValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasNUMTALON].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetNUMTALONIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasNUMTALON].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasNUMTALON].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasCODIGO].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasCODIGO].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetCODIGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCODIGO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCODIGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCODIGO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasPRODUCTO].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasPRODUCTO].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetPRODUCTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasPRODUCTO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasPRODUCTO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetGRUPOPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasGRUPOPRODUCTO].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetGRUPOPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasGRUPOPRODUCTO].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetGRUPOPRODUCTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasGRUPOPRODUCTO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetGRUPOPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasGRUPOPRODUCTO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTIPOPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasTIPOPRODUCTO].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetTIPOPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasTIPOPRODUCTO].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetTIPOPRODUCTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTIPOPRODUCTO].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTIPOPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTIPOPRODUCTO].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCOLECCIONValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasCOLECCION].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetCOLECCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasCOLECCION].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetCOLECCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCOLECCION].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCOLECCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCOLECCION].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasCOLOR].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasCOLOR].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetCOLORIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasCOLOR].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetCOLORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasCOLOR].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLAValue: String;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA].AsString;
end;

procedure TVentasTerminadasDataTableRules.SetTALLAValue(const aValue: String);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA].AsString := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLAIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA38Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA38].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA38Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA38].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA38IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA38].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA38IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA38].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA40Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA40].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA40Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA40].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA40IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA40].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA40IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA40].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA42Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA42].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA42Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA42].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA42IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA42].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA42IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA42].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA44Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA44].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA44Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA44].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA44IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA44].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA44IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA44].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA46Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA46].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA46Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA46].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA46IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA46].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA46IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA46].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTALLA48Value: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA48].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA48Value(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTALLA48].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTALLA48IsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTALLA48].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTALLA48IsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTALLA48].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVTATERMDEVValue: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasVTATERMDEV].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetVTATERMDEVValue(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasVTATERMDEV].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetVTATERMDEVIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVTATERMDEV].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVTATERMDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVTATERMDEV].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVTAFINALRESCValue: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasVTAFINALRESC].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetVTAFINALRESCValue(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasVTAFINALRESC].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetVTAFINALRESCIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVTAFINALRESC].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVTAFINALRESCIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVTAFINALRESC].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVENTASValue: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasVENTAS].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetVENTASValue(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasVENTAS].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetVENTASIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVENTAS].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVENTASIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVENTAS].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetDEVOLUCIONESValue: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasDEVOLUCIONES].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetDEVOLUCIONESValue(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasDEVOLUCIONES].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetDEVOLUCIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasDEVOLUCIONES].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetDEVOLUCIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasDEVOLUCIONES].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetTOTALValue: TBcd;
begin
  result := DataTable.Fields[idx_VentasTerminadasTOTAL].AsDecimal;
end;

procedure TVentasTerminadasDataTableRules.SetTOTALValue(const aValue: TBcd);
begin
  DataTable.Fields[idx_VentasTerminadasTOTAL].AsDecimal := aValue;
end;

function TVentasTerminadasDataTableRules.GetTOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasTOTAL].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetTOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasTOTAL].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVALTERMDEVValue: Currency;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALTERMDEV].AsCurrency;
end;

procedure TVentasTerminadasDataTableRules.SetVALTERMDEVValue(const aValue: Currency);
begin
  DataTable.Fields[idx_VentasTerminadasVALTERMDEV].AsCurrency := aValue;
end;

function TVentasTerminadasDataTableRules.GetVALTERMDEVIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALTERMDEV].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVALTERMDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVALTERMDEV].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVALFINALRESCValue: Currency;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALFINALRESC].AsCurrency;
end;

procedure TVentasTerminadasDataTableRules.SetVALFINALRESCValue(const aValue: Currency);
begin
  DataTable.Fields[idx_VentasTerminadasVALFINALRESC].AsCurrency := aValue;
end;

function TVentasTerminadasDataTableRules.GetVALFINALRESCIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALFINALRESC].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVALFINALRESCIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVALFINALRESC].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVALVENValue: Currency;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALVEN].AsCurrency;
end;

procedure TVentasTerminadasDataTableRules.SetVALVENValue(const aValue: Currency);
begin
  DataTable.Fields[idx_VentasTerminadasVALVEN].AsCurrency := aValue;
end;

function TVentasTerminadasDataTableRules.GetVALVENIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALVEN].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVALVENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVALVEN].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVALDEVValue: Currency;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALDEV].AsCurrency;
end;

procedure TVentasTerminadasDataTableRules.SetVALDEVValue(const aValue: Currency);
begin
  DataTable.Fields[idx_VentasTerminadasVALDEV].AsCurrency := aValue;
end;

function TVentasTerminadasDataTableRules.GetVALDEVIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALDEV].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVALDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVALDEV].AsVariant := Null;
end;

function TVentasTerminadasDataTableRules.GetVALTOTValue: Currency;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALTOT].AsCurrency;
end;

procedure TVentasTerminadasDataTableRules.SetVALTOTValue(const aValue: Currency);
begin
  DataTable.Fields[idx_VentasTerminadasVALTOT].AsCurrency := aValue;
end;

function TVentasTerminadasDataTableRules.GetVALTOTIsNull: boolean;
begin
  result := DataTable.Fields[idx_VentasTerminadasVALTOT].IsNull;
end;

procedure TVentasTerminadasDataTableRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_VentasTerminadasVALTOT].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_VentasTerminadasCrossTab, TVentasTerminadasCrossTabDataTableRules);
  RegisterDataTableRules(RID_VentasTerminadas, TVentasTerminadasDataTableRules);

end.
